import argparse
import configparser
import logging
import pathlib

import matplotlib.pyplot as plt
import numpy as np
from scipy import interpolate

from .olaflow import OFModel

parser = argparse.ArgumentParser(description="Convert swash output to olaFlow input")
parser.add_argument("-v", "--verbose", action="count", default=0)
parser.add_argument("-c", "--config", default="config.ini")
parser.add_argument("-o", "--output", type=pathlib.Path)
args = parser.parse_args()

logging.basicConfig(level=max((10, 20 - 10 * args.verbose)))
log = logging.getLogger("sws_ola")

log.info("Starting sws -> olaFlow converter")
config = configparser.ConfigParser()
config.read(args.config)

sws_out = pathlib.Path(config.get("swash", "np_out"))


def data(var):
    return np.load(sws_out.joinpath(f"{var}.npy"))


t0 = config.getfloat("olaflow", "t0")
x = data("x")
t = data("t")

arg_t0 = np.argmin(np.abs(t - t0 * 1e3))

watl = data("watl")
zk = data("zk")
velk, _ = data("velk")
vz = data("vz")

olaflow_root = args.output
model = OFModel(olaflow_root)
model.read_mesh()

level = config.getfloat("bathy", "level", fallback=0.0)
watl_t = interpolate.interp1d(x, watl[arg_t0] + level)
alpha_water = np.where(model.z < watl_t(model.x), 1, 0)

zk_t = interpolate.interp1d(x, zk[arg_t0] + level)
velk_t = interpolate.interp1d(x, velk[arg_t0, :, :])(model.x)
vz_t = interpolate.interp1d(x, vz[arg_t0])(model.x)
zk_tl = zk_t(model.x)

ux = np.zeros(model.x.shape)
uy = np.zeros(model.x.shape)
uz = np.zeros(model.x.shape)
for zk_l, velk_l, vz_l in zip(zk_tl, velk_t, vz_t):
    ux = np.where(model.z < zk_l, velk_l, ux)
    uz = np.where(model.z < zk_l, vz_l, uz)

model.write_field("alpha.water", alpha_water)
model.write_vector_field("U", np.stack((ux, uy, uz)).T)
